SystemOrganization addCategory: #TechnologyTreeOptimizationOfTheCivilizationRevolution!

Object subclass: #CRGame
	instanceVariableNames: 'techs techsAquired'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 02:14'!
aquireTechNamed: aString

	techsAquired add: (self techNamed: aString)! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 02:55'!
aquireTechOrderToReachTechNamed: aByteString 

	| ds |
	ds := CRTechDependencySorter new.
	ds techs: techs.
	ds insert: (self techNamed: aByteString).
	techsAquired addAll: ds sortedCollection.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 02:16'!
aquireTechsNamed: anArray 

	anArray do: [:each| self aquireTechNamed: each ]! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:55'!
countOfTechsOfLevel: aSmallInteger 

	^(self techsOfLevel: aSmallInteger) size! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 02:13'!
initialize

	super initialize.
	self initializeTechs.
	techsAquired := Set new.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 00:48'!
initializeTechs

	techs := CRTech allTechs.
	self setUpTechRequirements.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:27'!
setUpRequirementTechsOfTechNamed: techName withTechNames: anArray

	(self techNamed: techName) requiredTechs: (anArray collect: [:requiredTechName| self techNamed: requiredTechName]).! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 00:48'!
setUpTechRequirements

	self setUpRequirementTechsOfTechNamed: 'Ceremonial Burial' withTechNames: {'Pottery'}.
	self setUpRequirementTechsOfTechNamed: 'Iron Working' withTechNames: {'Bronze Working'}.
	self setUpRequirementTechsOfTechNamed: 'Masonry' withTechNames: {'Pottery'}.
	self setUpRequirementTechsOfTechNamed: 'Writing' withTechNames:  {'Alphabet'}.
	self setUpRequirementTechsOfTechNamed: 'Code of Laws' withTechNames:  {'Alphabet'. 'Writing'}.
	self setUpRequirementTechsOfTechNamed: 'Construction' withTechNames:  {'Iron Working'. 'Masonry'}.
	self setUpRequirementTechsOfTechNamed: 'Irrigation' withTechNames:  {'Pottery'. 'Masonry'}.
	self setUpRequirementTechsOfTechNamed: 'Literacy' withTechNames:  {'Alphabet'. 'Writing'}.
	self setUpRequirementTechsOfTechNamed: 'Mathematics' withTechNames:  {'Masonry'. 'Writing'}.
	self setUpRequirementTechsOfTechNamed: 'Currency' withTechNames:  {'Bronze Working'. 'Code of Laws'}.
	self setUpRequirementTechsOfTechNamed: 'Democracy' withTechNames:  {'Code of Laws'. 'Literacy'}.
	self setUpRequirementTechsOfTechNamed: 'Engineering' withTechNames:  {'Construction'. 'Mathematics'}.
	self setUpRequirementTechsOfTechNamed: 'Monarchy' withTechNames:  {'Code of Laws'. 'Ceremonial Burial'. 'Writing'}.
	self setUpRequirementTechsOfTechNamed: 'Navigation' withTechNames:  {'Writing'. 'Mathematics'}.
	self setUpRequirementTechsOfTechNamed: 'Feudalism' withTechNames:  {'Monarchy'. 'Horseback Riding'}.
	self setUpRequirementTechsOfTechNamed: 'Religion' withTechNames:  {'Monarchy'. 'Ceremonial Burial'}.
	self setUpRequirementTechsOfTechNamed: 'Banking' withTechNames:  {'Currency'. 'Code of Laws'. 'Literacy'}.
	self setUpRequirementTechsOfTechNamed: 'University' withTechNames:  {'Democracy'. 'Mathematics'. 'Literacy'}.
	self setUpRequirementTechsOfTechNamed: 'Invention' withTechNames:  {'Engineering'. 'Literacy'}.
	self setUpRequirementTechsOfTechNamed: 'Gunpowder' withTechNames:  {'Feudalism'. 'Invention'}.
	self setUpRequirementTechsOfTechNamed: 'Metallurgy' withTechNames:  {'University'. 'Engineering'. 'Iron Working'}.
	self setUpRequirementTechsOfTechNamed: 'Printing Press' withTechNames:  {'Religion'. 'University'}.
	self setUpRequirementTechsOfTechNamed: 'Steam Power' withTechNames:  {'Invention'. 'Engineering'. 'Iron Working'}.
	self setUpRequirementTechsOfTechNamed: 'Combustion' withTechNames:  {'Gunpowder'. 'Metallurgy'. 'Steam Power'}.
	self setUpRequirementTechsOfTechNamed: 'Electricity' withTechNames:  {'Metallurgy'. 'Engineering'. 'Steam Power'}.
	self setUpRequirementTechsOfTechNamed: 'Industrialization' withTechNames:  {'Banking'. 'Steam Power'}.
	self setUpRequirementTechsOfTechNamed: 'Railroad' withTechNames:  {'Steam Power'}.
	self setUpRequirementTechsOfTechNamed: 'Steel' withTechNames:  {'Metallurgy'. 'Steam Power'}.
	self setUpRequirementTechsOfTechNamed: 'Communism' withTechNames:  {'Industrialization'. 'University'}.
	self setUpRequirementTechsOfTechNamed: 'Flight' withTechNames:  {'Combustion'. 'Metallurgy'. 'Invention'}.
	self setUpRequirementTechsOfTechNamed: 'Mass Production' withTechNames:  {'Industrialization'. 'Railroad'}.
	self setUpRequirementTechsOfTechNamed: 'The Corporation' withTechNames:  {'Industrialization'. 'Banking'}.
	self setUpRequirementTechsOfTechNamed: 'Atomic Theory' withTechNames:  {'University'. 'Invention'. 'Electricity'}.
	self setUpRequirementTechsOfTechNamed: 'The Automobile' withTechNames:  {'Combustion'. 'Steel'}.
	self setUpRequirementTechsOfTechNamed: 'Electronics' withTechNames:  {'The Corporation'. 'Electricity'}.
	self setUpRequirementTechsOfTechNamed: 'Mass Media' withTechNames:  {'The Corporation'. 'Printing Press'}.
	self setUpRequirementTechsOfTechNamed: 'Advanced Flight' withTechNames:  {'Industrialization'. 'Flight'}.
	self setUpRequirementTechsOfTechNamed: 'Nuclear Power' withTechNames:  {'Mass Production'. 'Atomic Theory'}.
	self setUpRequirementTechsOfTechNamed: 'Networking' withTechNames:  {'Electronics'. 'The Corporation'}.
	self setUpRequirementTechsOfTechNamed: 'Space Flight' withTechNames:  {'Electronics'. 'Advanced Flight'. 'Nuclear Power'}.
	self setUpRequirementTechsOfTechNamed: 'Globalization' withTechNames:  {'Networking'. 'Mass Media'}.
	self setUpRequirementTechsOfTechNamed: 'Superconductor' withTechNames:  {'Space Flight'. 'Mass Production'}.
	self setUpRequirementTechsOfTechNamed: 'Future Technology' withTechNames:  {'Globalization'. 'Superconductor'. 'Advanced Flight'}.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:23'!
techNamed: aByteString 

	^techs detect: [:each| each techName = aByteString ]! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 01:29'!
techOrderToReachTechNamed: aByteString 

	| ds |
	ds := CRTechDependencySorter new.
	ds techs: techs.
	ds insert: (self techNamed: aByteString).
	^(ds sortedCollection asSortedCollection: #level ascendingSortBlock) collect: #techName.! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:54'!
techsOfLevel: aSmallInteger 

	^techs select: [:each| each level = aSmallInteger ]  ! !

!CRGame methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 02:23'!
unaquiredTechOrderToReachTechNamed: aByteString 
	
	| ds |
	ds := CRTechDependencySorter new.
	ds techs: techs.
	ds insert: (self techNamed: aByteString).
	^((ds sortedCollection asSortedCollection: #level ascendingSortBlock) copyWithoutAll: techsAquired) collect: #techName.! !

Object subclass: #CRTech
	uses: HashProofTrait
	instanceVariableNames: 'requiredTechs techName bonus level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

CRTech class
	uses: HashProofTrait classTrait
	instanceVariableNames: ''!

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:19'!
allTechs

	|techs|
	techs := (self class selectors select: [:each| each beginsWith: 'tech' ])
		collect: [:sym| self perform: sym  ].
	^techs! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:18'!
newTechName: aByteString level: aSmallInteger

	|instance|
	instance := self new.
	instance techName: aByteString.
	instance level: aSmallInteger.
	^instance! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:44'!
techAdvancedFlight

	^self newTechName: 'Advanced Flight' level: 9! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:17'!
techAlphabet

	^self newTechName: 'Alphabet' level: 1! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:43'!
techAtomicTheory

	^self newTechName: 'Atomic Theory' level: 8! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:37'!
techBanking

	^self newTechName: 'Banking' level: 5! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:18'!
techBronzeWorking

	^self newTechName: 'Bronze Working' level: 1! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:18'!
techCeremonialBurial

	^self newTechName: 'Ceremonial Burial' level: 2! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:33'!
techCodeOfLaws

	^self newTechName: 'Code of Laws' level: 3! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:39'!
techCombustion

	^self newTechName: 'Combustion' level: 7! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:41'!
techCommunism

	^self newTechName: 'Communism' level: 8! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:33'!
techConstruction

	^self newTechName: 'Construction' level: 3! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:35'!
techCurrency

	^self newTechName: 'Currency' level: 4! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:35'!
techDemocracy

	^self newTechName: 'Democracy' level: 4! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:40'!
techElectricity

	^self newTechName: 'Electricity' level: 7! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:43'!
techElectronics

	^self newTechName: 'Electronics' level: 9! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:35'!
techEngineering

	^self newTechName: 'Engineering' level: 4! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:36'!
techFeudalism

	^self newTechName: 'Feudalism' level: 5! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:42'!
techFlight

	^self newTechName: 'Flight' level: 8! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:46'!
techFutureTechnology

	^self newTechName: 'Future Technology' level: 12! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:45'!
techGlobalization

	^self newTechName: 'Globalization' level: 11! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:38'!
techGunpowder

	^self newTechName: 'Gunpowder' level: 6! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:18'!
techHorsebackRiding

	^self newTechName: 'Horseback Riding' level: 1! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:40'!
techIndustrialization

	^self newTechName: 'Industrialization' level: 7! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:37'!
techInvention

	^self newTechName: 'Invention' level: 5! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:18'!
techIronWorking

	^self newTechName: 'Iron Working' level: 2! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:34'!
techIrrigation

	^self newTechName: 'Irrigation' level: 3! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:34'!
techLiteracy

	^self newTechName: 'Literacy' level: 3! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:30'!
techMasonry

	^self newTechName: 'Masonry' level: 2! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:44'!
techMassMedia

	^self newTechName: 'Mass Media' level: 9! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:42'!
techMassProduction

	^self newTechName: 'Mass Production' level: 8! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:34'!
techMathematics

	^self newTechName: 'Mathematics' level: 3! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:38'!
techMetallurgy

	^self newTechName: 'Metallurgy' level: 6! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:35'!
techMonarchy

	^self newTechName: 'Monarchy' level: 4! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:36'!
techNavigation

	^self newTechName: 'Navigation' level: 4! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:45'!
techNetworking

	^self newTechName: 'Networking' level: 10! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:44'!
techNuclearPower

	^self newTechName: 'Nuclear Power' level: 9! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:18'!
techPottery

	^self newTechName: 'Pottery' level: 1! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:38'!
techPrintingPress

	^self newTechName: 'Printing Press' level: 6! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:40'!
techRailroad

	^self newTechName: 'Railroad' level: 7! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:37'!
techReligion

	^self newTechName: 'Religion' level: 5! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:45'!
techSpaceFlight

	^self newTechName: 'Space Flight' level: 10! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:39'!
techSteamPower

	^self newTechName: 'Steam Power' level: 6! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:41'!
techSteel

	^self newTechName: 'Steel' level: 7! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:46'!
techSuperconductor

	^self newTechName: 'Superconductor' level: 11! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:43'!
techTheAutomobile

	^self newTechName: 'The Automobile' level: 8! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:42'!
techTheCorporation

	^self newTechName: 'The Corporation' level: 8! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:37'!
techUniversity

	^self newTechName: 'University' level: 5! !

!CRTech classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:31'!
techWriting

	^self newTechName: 'Writing' level: 2! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
bonus
	^ bonus! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
bonus: anObject
	bonus := anObject! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 02:17'!
gettersForEquality

	^#(techName)! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 00:55'!
initialize 

	super initialize.
	requiredTechs := {}.! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:51'!
level

	^ level! !

!CRTech methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:04'!
level: aSmallInteger 

	level := aSmallInteger! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
requiredTechs
	^ requiredTechs! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
requiredTechs: anObject
	requiredTechs := anObject! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
techName
	^ techName! !

!CRTech methodsFor: 'accessing' stamp: 'hjo 9/13/2011 22:52'!
techName: anObject
	techName := anObject! !

TestCase subclass: #CRGameTechSetUpTest
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:48'!
setUp

	game := CRGame new.! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:49'!
testLevel1

	self assert: (game countOfTechsOfLevel:1) equals: 4.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:58'!
testLevel10

	self assert: (game countOfTechsOfLevel:10) equals: 2.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:58'!
testLevel11

	self assert: (game countOfTechsOfLevel:11) equals: 2.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:58'!
testLevel12

	self assert: (game countOfTechsOfLevel:12) equals: 1.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:51'!
testLevel2

	self assert: (game countOfTechsOfLevel:2) equals: 4.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:52'!
testLevel3

	self assert: (game countOfTechsOfLevel:3) equals: 5.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:56'!
testLevel4

	self assert: (game countOfTechsOfLevel:4) equals: 5.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:56'!
testLevel5

	self assert: (game countOfTechsOfLevel:5) equals: 5.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:56'!
testLevel6

	self assert: (game countOfTechsOfLevel:6) equals: 4.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:57'!
testLevel7

	self assert: (game countOfTechsOfLevel:7) equals: 5.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:57'!
testLevel8

	self assert: (game countOfTechsOfLevel:8) equals: 6.
	! !

!CRGameTechSetUpTest methodsFor: 'as yet unclassified' stamp: 'hjo 9/13/2011 23:57'!
testLevel9

	self assert: (game countOfTechsOfLevel:9) equals: 4.
	! !

DependencySorter subclass: #CRTechDependencySorter
	instanceVariableNames: 'techs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TechnologyTreeOptimizationOfTheCivilizationRevolution'!

!CRTechDependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 9/14/2011 00:50'!
prerequisitesOf: aTech

	^aTech requiredTechs  ! !

!CRTechDependencySorter methodsFor: 'accessing' stamp: 'hjo 9/14/2011 00:49'!
techs
	^ techs! !

!CRTechDependencySorter methodsFor: 'accessing' stamp: 'hjo 9/14/2011 00:49'!
techs: anArray
	techs := anArray! !
